
/*  A Bison parser, made from s2ibis.y with Bison version GNU Bison version 1.24
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	COMPONENT_VOLTAGE_RANGE	258
#define	COMPONENT_DERATE_RAMP	259
#define	COMPONENT_POWER_CLAMP	260
#define	COMPONENT_TEMP_RANGE	261
#define	GLOBAL_VOLTAGE_RANGE	262
#define	COMPONENT_DERATE_VI	263
#define	COMPONENT_GND_CLAMP	264
#define	COMPONENT_SIM_TIME	265
#define	COMPONENT_PULLDOWN	266
#define	GLOBAL_DERATE_RAMP	267
#define	GLOBAL_POWER_CLAMP	268
#define	GLOBAL_TEMP_RANGE	269
#define	GLOBAL_DERATE_VI	270
#define	GLOBAL_GND_CLAMP	271
#define	COMPONENT_C_COMP	272
#define	COMPONENT_PULLUP	273
#define	COMPONENT_R_PKG	274
#define	COMPONENT_L_PKG	275
#define	COMPONENT_C_PKG	276
#define	COMPONENT_RLOAD	277
#define	GLOBAL_SIM_TIME	278
#define	GLOBAL_PULLDOWN	279
#define	I_O_OPEN_SOURCE	280
#define	SCALED_FLOATLIT	281
#define	I_O_OPEN_DRAIN	282
#define	NEXT_COMPONENT	283
#define	GLOBAL_C_COMP	284
#define	I_O_OPEN_SINK	285
#define	NON_INVERTING	286
#define	VOLTAGE_RANGE	287
#define	PACKAGE_MODEL	288
#define	GLOBAL_PULLUP	289
#define	SPICE_COMMAND	290
#define	IBIS_VERSION	291
#define	FALLING_WAVE	292
#define	COMMENT_CHAR	293
#define	MANUFACTURER	294
#define	GLOBAL_RLOAD	295
#define	GLOBAL_R_PKG	296
#define	GLOBAL_L_PKG	297
#define	GLOBAL_C_PKG	298
#define	VER_ONE_ONE	299
#define	VER_TWO_ONE	300
#define	RISING_WAVE	301
#define	ACTIVE_HIGH	302
#define	POWER_CLAMP	303
#define	OPEN_SOURCE	304
#define	DERATE_RAMP	305
#define	OUTPUT_ECL	306
#define	OPEN_DRAIN	307
#define	TEMP_RANGE	308
#define	DISCLAIMER	309
#define	ACTIVE_LOW	310
#define	MODEL_TYPE	311
#define	WHITESPACE	312
#define	TERMINATOR	313
#define	SPICE_FILE	314
#define	MODEL_FILE	315
#define	SPICE_TYPE	316
#define	CONT_LINE	317
#define	DERATE_VI	318
#define	OPEN_SINK	319
#define	COMPONENT	320
#define	INVERTING	321
#define	FILE_NAME	322
#define	COPYRIGHT	323
#define	GND_CLAMP	324
#define	INPUT_ECL	325
#define	TRI_STATE	326
#define	DIFF_PIN	327
#define	PULLDOWN	328
#define	POLARITY	329
#define	FILE_REV	330
#define	SIM_TIME	331
#define	ITERATE	332
#define	PIN_MAP	333
#define	PACKAGE	334
#define	DV_DT_R	335
#define	DV_DT_F	336
#define	I_O_ECL	337
#define	SPECTRE	338
#define	CLEANUP	339
#define	ENABLE	340
#define	SOURCE	341
#define	PULLUP	342
#define	C_COMP	343
#define	RPOWER	344
#define	END_kw	345
#define	OUTPUT	346
#define	PSPICE	347
#define	HSPICE	348
#define	SPICE2	349
#define	SPICE3	350
#define	R_PIN	351
#define	L_PIN	352
#define	C_PIN	353
#define	POWER	354
#define	NOTES	355
#define	RLOAD	356
#define	VMEAS	357
#define	MODEL	358
#define	INPUT	359
#define	VINL	360
#define	VINH	361
#define	DATE	362
#define	RAMP	363
#define	OVER	364
#define	CREF	365
#define	RREF	366
#define	VREF	367
#define	RGND	368
#define	I_O	369
#define	GND	370
#define	RAC	371
#define	CAC	372
#define	PIN	373
#define	eol	374
#define	eof	375
#define	NC	376
#define	NA	377
#define	IDENTIFIER	378
#define	FLOATLIT	379
#define	INTLIT	380

#line 33 "s2ibis.y"



extern int maimed;			/* TRUE if fatal errors encountered */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#include "s2ibis.h"
#include "s2iutil.h"


#define YYMAXDEPTH 500
#define IDENTIFIERDEPTH 10
#define MAX_TMP_STRING_LEN (MAX_IBIS_STRING_LENGTH+10)

#define RET(token) return(token);

#ifdef DEBUG
#undef RET(token)
#define RET(token)	 if(token!=eol)\
            printf("\nlineNum = %d\t%s \ttoken = %d",lineNum,yytext,token);\
		  else\
            printf("\nlineNum = %d\teol \ttoken = %d",lineNum - 1,token);\
		return(token);
#endif

#define COPY_YYTEXT  idIndex = (thisDepth++) % YYMAXDEPTH;\
		  strncpy(yylvalStr[idIndex], yytext, MIN(MAX_TOK_LEN,yyleng));


/*------------------------------------------------------------------------
*
*	The following globals are used by the lexer (s2ibis.lex).
*
*-----------------------------------------------------------------------*/
static char 		yylvalStr[YYMAXDEPTH][MAX_TOK_LEN + 1],	
										/* text of yylval.id */
					*lastNumberAsText,
					x_char_char;		/* new comment character */


/*------------------------------------------------------------------------
*
*	The following globals are used by the parser (s2ibis.y).
*
*-----------------------------------------------------------------------*/
char				string[MAX_TMP_STRING_LEN+1],
					*any_string;
static char			commentChar = '|',
	     			universalCommentIndicator = 127; /* backspace character */

int					length,
					stringLength,
					idIndex,			/* used to index tokens */
					thisDepth,
					lineNum,			/* line number in input file */
					ibisVersion;

double				globalFloat, 
					globalFloat1;

static  FILE		yin;				/* file pointer for input */

ibisTOP_Pt			ibis_P;

ibisGlobal_Pt		global_P;

ibisComponent_Pt	component_P, *component_PP;

ibisTypMinMax_Pt	typMinMax_P;

ibisPackage_Pt		package_P;

ibisModel_Pt		model_P, *model_PP;

ibisPin_Pt			pin_P, *pin_PP;

ibisPinMap_Pt		pinMap_P, *pinMap_PP;

ibisDiffPin_Pt		diffPin_P, *diffPin_PP;

ibisWaveTable_Pt	risingWave_P, *risingWave_PP, 
					fallingWave_P, *fallingWave_PP;

/* static functions */
void create_String(char *sin, char **sout);
void initialize_IBIS(IN int versionID);
void setUp_Component(void);
int setUp_FileName(void);
int setUp_SpiceFileName(void);
ibisPin_Pt getMatchingPin( char[], ibisPin_Pt );


#line 139 "s2ibis.y"
typedef union {
	int ival;
	double dval;
	char *id;
	} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		418
#define	YYFLAG		-32768
#define	YYNTBASE	126

#define YYTRANSLATE(x) ((unsigned)(x) <= 380 ? yytranslate[x] : 237)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
   116,   117,   118,   119,   120,   121,   122,   123,   124,   125
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     9,    10,    18,    20,    21,    26,    29,    33,
    37,    38,    44,    48,    49,    55,    59,    63,    67,    71,
    75,    79,    80,    86,    87,    93,    94,   100,   101,   107,
   108,   114,   115,   121,   126,   131,   136,   141,   142,   148,
   149,   155,   156,   162,   163,   169,   172,   175,   178,   181,
   184,   187,   188,   193,   194,   198,   199,   205,   209,   210,
   216,   217,   223,   224,   230,   231,   237,   238,   244,   245,
   251,   256,   261,   266,   271,   272,   278,   279,   285,   286,
   292,   293,   299,   304,   305,   311,   316,   317,   324,   325,
   329,   330,   331,   332,   333,   343,   344,   345,   349,   350,
   354,   355,   356,   357,   365,   366,   367,   371,   372,   376,
   383,   390,   391,   392,   393,   394,   404,   406,   407,   411,
   412,   413,   414,   420,   421,   426,   431,   434,   437,   442,
   447,   452,   457,   462,   467,   472,   477,   482,   487,   488,
   494,   495,   501,   502,   508,   509,   515,   516,   522,   523,
   529,   530,   536,   537,   543,   544,   550,   551,   557,   558,
   564,   565,   570,   571,   576,   578,   580,   582,   584,   586,
   588,   590,   592,   594,   596,   598,   600,   602,   604,   608,
   612,   616,   620,   621,   622,   623,   624,   625,   626,   627,
   628,   629,   649,   650,   651,   652,   653,   654,   655,   656,
   657,   658,   678,   679,   680,   686,   688,   691,   693,   695,
   697,   699,   701,   703,   705,   706,   707,   713,   715,   717,
   719,   721,   722,   726,   727,   730,   732
};

static const short yyrhs[] = {    -1,
   226,    36,    45,   127,   226,   129,   120,     0,     0,   226,
    36,    44,   128,   226,   129,   120,     0,     1,     0,     0,
   129,    38,   227,   226,     0,   129,     1,     0,   129,    84,
   226,     0,   129,    77,   226,     0,     0,   129,    67,   227,
   130,   226,     0,   129,    61,   142,     0,     0,   129,    75,
   227,   131,   226,     0,   129,   107,   233,     0,   129,    35,
   233,     0,   129,    86,   233,     0,   129,   100,   233,     0,
   129,    54,   233,     0,   129,    68,   233,     0,     0,   129,
    14,   132,   228,   226,     0,     0,   129,     7,   133,   228,
   226,     0,     0,   129,    34,   134,   228,   226,     0,     0,
   129,    24,   135,   228,   226,     0,     0,   129,    13,   136,
   228,   226,     0,     0,   129,    16,   137,   228,   226,     0,
   129,    40,   232,   226,     0,   129,    15,   232,   226,     0,
   129,    12,   232,   226,     0,   129,    23,   232,   226,     0,
     0,   129,    29,   138,   228,   226,     0,     0,   129,    41,
   139,   228,   226,     0,     0,   129,    42,   140,   228,   226,
     0,     0,   129,    43,   141,   228,   226,     0,   129,   143,
     0,    93,   226,     0,    92,   226,     0,    94,   226,     0,
    95,   226,     0,    83,   226,     0,     0,    65,   233,   144,
   145,     0,     0,   145,    39,   233,     0,     0,   145,    59,
   227,   146,   226,     0,   145,    33,   233,     0,     0,   145,
     6,   147,   228,   226,     0,     0,   145,     3,   148,   228,
   226,     0,     0,   145,    18,   149,   228,   226,     0,     0,
   145,    11,   150,   228,   226,     0,     0,   145,     5,   151,
   228,   226,     0,     0,   145,     9,   152,   228,   226,     0,
   145,    22,   232,   226,     0,   145,     8,   232,   226,     0,
   145,     4,   232,   226,     0,   145,    10,   232,   226,     0,
     0,   145,    17,   153,   228,   226,     0,     0,   145,    19,
   154,   228,   226,     0,     0,   145,    20,   155,   228,   226,
     0,     0,   145,    21,   156,   228,   226,     0,   145,    72,
   226,   159,     0,     0,   145,    78,   226,   157,   167,     0,
   145,   118,   226,   174,     0,     0,   145,   103,   227,   158,
   226,   186,     0,     0,   159,   160,   226,     0,     0,     0,
     0,     0,   227,   161,   227,   162,   231,   163,   231,   164,
   165,     0,     0,     0,   231,   166,   231,     0,     0,   167,
   168,   226,     0,     0,     0,     0,   227,   169,   227,   170,
   227,   171,   172,     0,     0,     0,   227,   173,   227,     0,
     0,   174,   175,   226,     0,   174,   175,   119,    62,   181,
   226,     0,   174,   175,   119,    62,   180,   226,     0,     0,
     0,     0,     0,   227,   176,   227,   177,   227,   178,   227,
   179,   183,     0,   227,     0,     0,   227,   182,   227,     0,
     0,     0,     0,   231,   184,   231,   185,   231,     0,     0,
   186,    56,   200,   226,     0,   186,    60,   223,   226,     0,
   186,   201,     0,   186,   202,     0,   186,    76,   232,   226,
     0,   186,   105,   232,   226,     0,   186,   106,   232,   226,
     0,   186,   102,   232,   226,     0,   186,   110,   232,   226,
     0,   186,   111,   232,   226,     0,   186,   112,   232,   226,
     0,   186,   101,   232,   226,     0,   186,    50,   232,   226,
     0,   186,    63,   232,   226,     0,     0,   186,    88,   187,
   228,   226,     0,     0,   186,    53,   188,   228,   226,     0,
     0,   186,    32,   189,   228,   226,     0,     0,   186,    87,
   190,   228,   226,     0,     0,   186,    73,   191,   228,   226,
     0,     0,   186,    48,   192,   228,   226,     0,     0,   186,
    69,   193,   228,   226,     0,     0,   186,   113,   194,   228,
   226,     0,     0,   186,    89,   195,   228,   226,     0,     0,
   186,   116,   196,   228,   226,     0,     0,   186,   117,   197,
   228,   226,     0,     0,   186,    46,   198,   203,     0,     0,
   186,    37,   199,   213,     0,   104,     0,    91,     0,    71,
     0,    52,     0,   114,     0,    27,     0,    30,     0,    25,
     0,    70,     0,    82,     0,    58,     0,    64,     0,    49,
     0,    51,     0,    74,    31,   226,     0,    74,    66,   226,
     0,    85,    47,   226,     0,    85,    55,   226,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   232,   204,
   232,   205,   231,   206,   231,   207,   231,   208,   231,   209,
   231,   210,   231,   211,   231,   212,   226,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   232,   214,   232,
   215,   231,   216,   231,   217,   231,   218,   231,   219,   231,
   220,   231,   221,   231,   222,   226,     0,     0,     0,   227,
   224,   227,   225,   227,     0,   119,     0,   226,   119,     0,
   123,     0,   125,     0,   124,     0,   115,     0,    99,     0,
   121,     0,   122,     0,     0,     0,   231,   229,   231,   230,
   231,     0,   232,     0,   122,     0,   124,     0,   125,     0,
     0,   234,   236,   235,     0,     0,   235,   236,     0,   227,
     0,   119,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   293,   295,   296,   298,   299,   312,   313,   318,   319,   321,
   323,   326,   326,   327,   330,   330,   332,   334,   336,   338,
   340,   342,   344,   345,   347,   348,   350,   351,   353,   354,
   356,   357,   359,   360,   362,   364,   366,   368,   370,   371,
   373,   374,   376,   377,   379,   380,   388,   389,   390,   391,
   392,   401,   404,   407,   408,   413,   416,   416,   421,   423,
   424,   426,   427,   429,   430,   432,   433,   435,   436,   438,
   439,   441,   443,   445,   447,   449,   450,   452,   453,   455,
   456,   458,   459,   461,   464,   464,   466,   476,   490,   491,
   494,   501,   504,   506,   508,   510,   512,   515,   528,   529,
   532,   540,   543,   546,   548,   549,   553,   586,   587,   588,
   589,   592,   599,   604,   609,   613,   615,   621,   626,   637,
   638,   639,   640,   649,   650,   651,   652,   653,   654,   658,
   662,   666,   670,   674,   678,   682,   686,   690,   694,   698,
   699,   703,   704,   708,   709,   713,   714,   718,   719,   723,
   724,   728,   729,   733,   734,   738,   739,   743,   744,   748,
   749,   756,   756,   763,   767,   769,   771,   773,   775,   777,
   779,   781,   783,   785,   787,   789,   791,   793,   797,   799,
   803,   805,   810,   811,   812,   813,   814,   815,   816,   817,
   818,   820,   822,   823,   824,   825,   826,   827,   828,   829,
   830,   832,   834,   840,   845,   854,   855,   858,   859,   860,
   861,   862,   863,   864,   867,   868,   869,   872,   873,   876,
   877,   881,   883,   886,   887,   890,   900
};

static const char * const yytname[] = {   "$","error","$undefined.","COMPONENT_VOLTAGE_RANGE",
"COMPONENT_DERATE_RAMP","COMPONENT_POWER_CLAMP","COMPONENT_TEMP_RANGE","GLOBAL_VOLTAGE_RANGE",
"COMPONENT_DERATE_VI","COMPONENT_GND_CLAMP","COMPONENT_SIM_TIME","COMPONENT_PULLDOWN",
"GLOBAL_DERATE_RAMP","GLOBAL_POWER_CLAMP","GLOBAL_TEMP_RANGE","GLOBAL_DERATE_VI",
"GLOBAL_GND_CLAMP","COMPONENT_C_COMP","COMPONENT_PULLUP","COMPONENT_R_PKG","COMPONENT_L_PKG",
"COMPONENT_C_PKG","COMPONENT_RLOAD","GLOBAL_SIM_TIME","GLOBAL_PULLDOWN","I_O_OPEN_SOURCE",
"SCALED_FLOATLIT","I_O_OPEN_DRAIN","NEXT_COMPONENT","GLOBAL_C_COMP","I_O_OPEN_SINK",
"NON_INVERTING","VOLTAGE_RANGE","PACKAGE_MODEL","GLOBAL_PULLUP","SPICE_COMMAND",
"IBIS_VERSION","FALLING_WAVE","COMMENT_CHAR","MANUFACTURER","GLOBAL_RLOAD","GLOBAL_R_PKG",
"GLOBAL_L_PKG","GLOBAL_C_PKG","VER_ONE_ONE","VER_TWO_ONE","RISING_WAVE","ACTIVE_HIGH",
"POWER_CLAMP","OPEN_SOURCE","DERATE_RAMP","OUTPUT_ECL","OPEN_DRAIN","TEMP_RANGE",
"DISCLAIMER","ACTIVE_LOW","MODEL_TYPE","WHITESPACE","TERMINATOR","SPICE_FILE",
"MODEL_FILE","SPICE_TYPE","CONT_LINE","DERATE_VI","OPEN_SINK","COMPONENT","INVERTING",
"FILE_NAME","COPYRIGHT","GND_CLAMP","INPUT_ECL","TRI_STATE","DIFF_PIN","PULLDOWN",
"POLARITY","FILE_REV","SIM_TIME","ITERATE","PIN_MAP","PACKAGE","DV_DT_R","DV_DT_F",
"I_O_ECL","SPECTRE","CLEANUP","ENABLE","SOURCE","PULLUP","C_COMP","RPOWER","END_kw",
"OUTPUT","PSPICE","HSPICE","SPICE2","SPICE3","R_PIN","L_PIN","C_PIN","POWER",
"NOTES","RLOAD","VMEAS","MODEL","INPUT","VINL","VINH","DATE","RAMP","OVER","CREF",
"RREF","VREF","RGND","I_O","GND","RAC","CAC","PIN","eol","eof","NC","NA","IDENTIFIER",
"FLOATLIT","INTLIT","begin_parse","@1","@2","input_2.1","@3","@4","@5","@6",
"@7","@8","@9","@10","@11","@12","@13","@14","spice_type","component_1.0","@15",
"body_of_component_1.0","@16","@17","@18","@19","@20","@21","@22","@23","@24",
"@25","@26","@27","@28","body_of_diff_pin","diff_pin_line","@29","@30","@31",
"@32","maybe_tdelay_min_and_max","@33","body_of_pin_map","pin_map_line_type1",
"@34","@35","@36","maybe_clamp_refs","@37","body_of_pin","pin_line1","@38","@39",
"@40","@41","pin_line2_input_only","pin_line2_input_and_enable","@42","maybe_pin_rlc",
"@43","@44","body_of_model_2.0","@45","@46","@47","@48","@49","@50","@51","@52",
"@53","@54","@55","@56","@57","model_type_2.0","polarity_1.0","enable_1.0","body_of_rising_wave",
"@58","@59","@60","@61","@62","@63","@64","@65","@66","body_of_falling_wave",
"@67","@68","@69","@70","@71","@72","@73","@74","@75","model_file","@76","@77",
"eols","any_identifier","typ_min_max","@78","@79","number_or_NA","number_as_double",
"saveString","@80","saveString1","any_identifier_eol",""
};
#endif

static const short yyr1[] = {     0,
   127,   126,   128,   126,   126,   129,   129,   129,   129,   129,
   130,   129,   129,   131,   129,   129,   129,   129,   129,   129,
   129,   132,   129,   133,   129,   134,   129,   135,   129,   136,
   129,   137,   129,   129,   129,   129,   129,   138,   129,   139,
   129,   140,   129,   141,   129,   129,   142,   142,   142,   142,
   142,   144,   143,   145,   145,   146,   145,   145,   147,   145,
   148,   145,   149,   145,   150,   145,   151,   145,   152,   145,
   145,   145,   145,   145,   153,   145,   154,   145,   155,   145,
   156,   145,   145,   157,   145,   145,   158,   145,   159,   159,
   161,   162,   163,   164,   160,   165,   166,   165,   167,   167,
   169,   170,   171,   168,   172,   173,   172,   174,   174,   174,
   174,   176,   177,   178,   179,   175,   180,   182,   181,   183,
   184,   185,   183,   186,   186,   186,   186,   186,   186,   186,
   186,   186,   186,   186,   186,   186,   186,   186,   187,   186,
   188,   186,   189,   186,   190,   186,   191,   186,   192,   186,
   193,   186,   194,   186,   195,   186,   196,   186,   197,   186,
   198,   186,   199,   186,   200,   200,   200,   200,   200,   200,
   200,   200,   200,   200,   200,   200,   200,   200,   201,   201,
   202,   202,   204,   205,   206,   207,   208,   209,   210,   211,
   212,   203,   214,   215,   216,   217,   218,   219,   220,   221,
   222,   213,   224,   225,   223,   226,   226,   227,   227,   227,
   227,   227,   227,   227,   229,   230,   228,   231,   231,   232,
   232,   234,   233,   235,   235,   236,   236
};

static const short yyr2[] = {     0,
     0,     7,     0,     7,     1,     0,     4,     2,     3,     3,
     0,     5,     3,     0,     5,     3,     3,     3,     3,     3,
     3,     0,     5,     0,     5,     0,     5,     0,     5,     0,
     5,     0,     5,     4,     4,     4,     4,     0,     5,     0,
     5,     0,     5,     0,     5,     2,     2,     2,     2,     2,
     2,     0,     4,     0,     3,     0,     5,     3,     0,     5,
     0,     5,     0,     5,     0,     5,     0,     5,     0,     5,
     4,     4,     4,     4,     0,     5,     0,     5,     0,     5,
     0,     5,     4,     0,     5,     4,     0,     6,     0,     3,
     0,     0,     0,     0,     9,     0,     0,     3,     0,     3,
     0,     0,     0,     7,     0,     0,     3,     0,     3,     6,
     6,     0,     0,     0,     0,     9,     1,     0,     3,     0,
     0,     0,     5,     0,     4,     4,     2,     2,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     0,     5,
     0,     5,     0,     5,     0,     5,     0,     5,     0,     5,
     0,     5,     0,     5,     0,     5,     0,     5,     0,     5,
     0,     4,     0,     4,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
     3,     3,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    19,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    19,     0,     0,     5,     1,     2,     1,     1,     1,
     1,     1,     1,     1,     0,     0,     5,     1,     1,     1,
     1,     0,     3,     0,     2,     1,     1
};

static const short yydefact[] = {     0,
     5,   206,     0,     0,   207,     3,     1,     0,     0,     6,
     6,     0,     0,     8,    24,     0,    30,    22,     0,    32,
     0,    28,    38,    26,   222,     0,     0,    40,    42,    44,
   222,     0,   222,     0,   222,     0,     0,     0,   222,   222,
   222,     4,    46,     2,     0,   220,   221,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    17,     0,   212,   211,
   213,   214,   208,   210,   209,     0,     0,     0,     0,     0,
    20,     0,     0,     0,     0,     0,    13,    52,    11,    21,
    14,    10,     9,    18,    19,    16,   219,     0,   215,   218,
    36,     0,     0,    35,     0,    37,     0,     0,     0,   227,
   226,   224,     7,    34,     0,     0,     0,    51,    48,    47,
    49,    50,    54,     0,     0,    25,     0,    31,    23,    33,
    29,    39,    27,   223,    41,    43,    45,    53,    12,    15,
   216,   225,    61,     0,    67,    59,     0,    69,     0,    65,
    75,    63,    77,    79,    81,     0,   222,   222,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    58,    55,
    56,    89,    84,    87,   108,   217,     0,    73,     0,     0,
    72,     0,    74,     0,     0,     0,     0,     0,     0,    71,
     0,    83,    99,     0,    86,    62,    68,    60,    70,    66,
    76,    64,    78,    80,    82,    57,     0,    91,    85,   124,
     0,   112,    90,     0,     0,   101,    88,   206,   109,     0,
    92,   100,     0,   143,   163,   161,   149,     0,   141,     0,
     0,     0,   151,   147,     0,     0,     0,   145,   139,   155,
     0,     0,     0,     0,     0,     0,     0,   153,   157,   159,
   127,   128,     0,   113,     0,   102,     0,     0,     0,     0,
     0,     0,   172,   170,   171,   177,   178,   168,   175,   176,
   173,   167,   174,   166,   165,   169,     0,     0,   203,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   118,     0,    93,     0,     0,   164,   193,   162,
   183,     0,   137,     0,   125,   126,     0,   138,     0,     0,
   179,   180,   129,   181,   182,     0,     0,     0,   136,   132,
   130,   131,   133,   134,   135,     0,     0,     0,   111,   110,
     0,   114,     0,   103,   144,     0,     0,   150,   142,   204,
   152,   148,   146,   140,   156,   154,   158,   160,   119,     0,
    94,   105,   194,   184,     0,   115,    96,   104,   106,     0,
     0,   205,   120,    95,    97,     0,   195,   185,   116,   121,
     0,   107,     0,     0,     0,    98,   196,   186,   122,     0,
     0,     0,   197,   187,   123,     0,     0,   198,   188,     0,
     0,   199,   189,     0,     0,   200,   190,     0,     0,   201,
   191,     0,     0,   202,   192,     0,     0,     0
};

static const short yydefgoto[] = {   416,
     9,     8,    12,   114,   115,    50,    45,    56,    54,    49,
    52,    55,    68,    69,    70,    77,    43,   113,   128,   191,
   158,   155,   164,   162,   157,   160,   163,   165,   166,   167,
   193,   194,   192,   207,   214,   255,   343,   367,   374,   381,
   209,   215,   223,   306,   362,   368,   376,   195,   211,   220,
   304,   360,   373,   301,   302,   341,   379,   385,   392,   217,
   289,   262,   257,   288,   282,   260,   281,   298,   290,   299,
   300,   259,   258,   277,   251,   252,   310,   347,   371,   384,
   391,   397,   401,   405,   409,   413,   308,   346,   370,   383,
   390,   396,   400,   404,   408,   412,   278,   317,   365,     3,
   101,    88,   117,   154,    89,    90,    57,    58,   124,   102
};

static const short yypact[] = {     1,
-32768,-32768,   -33,   -31,-32768,-32768,-32768,  -114,  -114,  -111,
  -111,   462,   574,-32768,-32768,   -76,-32768,-32768,   -76,-32768,
   -76,-32768,-32768,-32768,-32768,   -52,   -76,-32768,-32768,-32768,
-32768,   -42,-32768,   -52,-32768,   -52,  -114,  -114,-32768,-32768,
-32768,-32768,-32768,-32768,  -103,-32768,-32768,  -114,  -103,  -103,
  -114,  -103,  -114,  -103,  -103,  -103,-32768,   -87,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  -114,  -114,  -103,  -103,  -103,
-32768,  -114,  -114,  -114,  -114,  -114,-32768,-32768,-32768,-32768,
-32768,  -111,  -111,-32768,-32768,-32768,-32768,  -114,-32768,-32768,
  -111,  -114,  -114,  -111,  -114,  -111,  -114,  -114,  -114,-32768,
-32768,-32768,  -111,  -111,  -114,  -114,  -114,  -111,  -111,  -111,
  -111,  -111,-32768,  -114,  -114,  -111,  -103,  -111,  -111,  -111,
  -111,  -111,  -111,   -87,  -111,  -111,  -111,   658,  -111,  -111,
-32768,-32768,-32768,   -76,-32768,-32768,   -76,-32768,   -76,-32768,
-32768,-32768,-32768,-32768,-32768,   -76,-32768,-32768,   -52,  -114,
  -114,   -52,  -114,  -103,  -103,  -114,  -103,  -103,  -114,  -103,
  -114,  -103,  -103,  -103,  -103,  -103,  -103,  -114,-32768,-32768,
-32768,  -111,  -111,-32768,  -111,-32768,  -114,  -111,  -114,  -114,
  -111,  -114,  -111,  -114,  -114,  -114,  -114,  -114,  -114,  -111,
  -114,   -52,-32768,  -114,   -52,  -111,  -111,  -111,  -111,  -111,
  -111,  -111,  -111,  -111,  -111,  -111,  -114,-32768,   -52,  -111,
  -109,-32768,  -111,   -52,  -114,-32768,   652,   -35,  -111,   -52,
-32768,  -111,   -52,-32768,-32768,-32768,-32768,   -76,-32768,    30,
   -52,   -76,-32768,-32768,   -27,   -76,   -40,-32768,-32768,-32768,
   -76,   -76,   -76,   -76,   -76,   -76,   -76,-32768,-32768,-32768,
-32768,-32768,   -52,-32768,  -103,-32768,  -103,   -76,   -76,  -103,
  -114,  -103,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,  -114,  -114,-32768,  -114,
  -103,  -103,  -114,  -114,  -114,  -114,  -114,  -103,  -103,  -103,
  -114,  -114,  -114,  -114,  -114,  -114,  -114,  -103,  -103,  -103,
  -114,  -114,   -77,   -52,-32768,   -52,  -114,-32768,-32768,-32768,
-32768,  -114,  -111,  -114,  -111,  -111,   -52,  -111,  -114,  -114,
  -111,  -111,  -111,  -111,  -111,  -114,  -114,  -114,  -111,  -111,
  -111,  -111,  -111,  -111,  -111,  -114,  -114,  -114,  -111,  -111,
   -52,-32768,  -103,-32768,  -111,   -76,   -76,  -111,  -111,-32768,
  -111,  -111,  -111,  -111,  -111,  -111,  -111,  -111,-32768,   -52,
-32768,   -52,-32768,-32768,   -52,-32768,  -103,-32768,-32768,  -103,
  -103,-32768,  -103,-32768,-32768,   -52,-32768,-32768,-32768,-32768,
  -103,-32768,  -103,  -103,  -103,-32768,-32768,-32768,-32768,  -103,
  -103,  -103,-32768,-32768,-32768,  -103,  -103,-32768,-32768,  -103,
  -103,-32768,-32768,  -103,  -103,-32768,-32768,  -103,  -103,-32768,
-32768,  -114,  -114,  -111,  -111,    44,    46,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,    43,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -8,
    -3,   295,-32768,-32768,    11,   -10,   -15,-32768,-32768,   -68
};


#define	YYLAST		776


static const short yytable[] = {    10,
    11,     1,     4,   283,     2,    48,   286,     5,    51,   218,
    53,    59,     6,     7,   287,    71,    67,    78,    87,    80,
    46,    47,    66,    84,    85,    86,   253,    60,    82,    83,
    79,   100,    81,    61,    62,    63,    64,    65,   284,    91,
    72,  -117,    94,   417,    96,   418,    59,    46,    47,    73,
    74,    75,    76,    13,   263,   132,   264,   103,   104,   265,
     0,     0,    60,   108,   109,   110,   111,   112,    61,    62,
    63,    64,    65,     0,     0,     0,     0,     0,   266,   116,
   267,   268,     0,   118,   119,     5,   120,   269,   121,   122,
   123,     0,     0,   270,     0,     0,   125,   126,   127,   271,
   272,     0,     0,     0,     0,   129,   130,     0,     0,     0,
     0,   273,     0,     0,     0,     0,     0,     0,     0,     2,
   274,     0,     0,   156,     0,     0,   159,   131,   161,     0,
     0,   169,   170,   275,     0,   168,     0,     0,     0,     0,
     0,   172,   173,   276,   175,   171,     0,   178,   174,     0,
   181,     0,   183,     0,     0,     0,     0,     0,     0,   190,
     0,     0,     0,     0,   176,     0,     0,     0,   196,     0,
   197,   198,     0,   199,     0,   200,   201,   202,   203,   204,
   205,     0,   206,     0,     0,   210,     0,     0,   208,     0,
     0,   212,     0,     0,     0,     0,     0,     0,   213,     0,
     0,     0,   219,     0,     0,   216,   222,     0,     0,     0,
   221,     0,     0,     0,     0,     0,   254,   261,     0,   256,
     0,   280,     0,     0,     0,   285,     0,   279,     0,     0,
   291,   292,   293,   294,   295,   296,   297,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   309,   311,   303,
     0,     0,   313,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   305,     0,     0,   315,   316,
     0,   318,     0,     0,   321,   322,   323,   324,   325,     0,
     0,     0,   329,   330,   331,   332,   333,   334,   335,     0,
     0,     0,   339,   340,     0,     0,     0,     0,   345,     0,
   342,     0,   344,   348,     0,   349,     0,     0,     0,     0,
   351,   352,     0,   350,     0,     0,     0,   353,   354,   355,
     0,     0,     0,     0,     0,     0,     0,   356,   357,   358,
     0,     0,     0,     0,     0,   363,   364,   359,     0,     0,
     0,     0,     0,    92,    93,     0,    95,     0,    97,    98,
    99,     0,     0,   361,     0,     0,   366,     0,   369,     0,
     0,   372,   105,   106,   107,     0,     0,     0,     0,     0,
     0,     0,   382,     0,     0,     0,     0,   375,     0,     0,
   377,   378,     0,   380,     0,     0,     0,     0,     0,     0,
     0,   386,     0,   387,   388,   389,     0,     0,     0,     0,
   393,   394,   395,   414,   415,     0,   398,   399,     0,     0,
   402,   403,     0,     0,   406,   407,     0,     0,   410,   411,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   177,
     0,   179,   180,     0,   182,     0,   184,   185,   186,   187,
   188,   189,    14,     0,     0,     0,     0,     0,    15,     0,
     0,     0,     0,    16,    17,    18,    19,    20,     0,     0,
     0,     0,     0,     0,    21,    22,     0,     0,     0,     0,
    23,     0,     0,     0,     0,    24,    25,     0,     0,    26,
     0,    27,    28,    29,    30,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
     0,     0,    32,     0,     0,     0,    33,     0,    34,    35,
     0,     0,     0,     0,     0,     0,    36,     0,    37,     0,
     0,     0,     0,     0,     0,    38,     0,    39,     0,     0,
     0,   307,     0,     0,   312,     0,   314,     0,     0,     0,
     0,    40,     0,     0,     0,     0,     0,     0,    41,     0,
     0,     0,     0,     0,    14,   319,   320,     0,     0,     0,
    15,    42,   326,   327,   328,    16,    17,    18,    19,    20,
     0,     0,   336,   337,   338,     0,    21,    22,     0,     0,
     0,     0,    23,     0,     0,     0,     0,    24,    25,     0,
     0,    26,     0,    27,    28,    29,    30,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    31,     0,     0,
     0,     0,     0,     0,    32,     0,     0,     0,    33,     0,
    34,    35,     0,     0,     0,     0,     0,     0,    36,     0,
    37,     0,     0,     0,     0,     0,     0,    38,     0,    39,
   133,   134,   135,   136,     0,   137,   138,   139,   140,     0,
     0,     0,     0,    40,   141,   142,   143,   144,   145,   146,
    41,     0,     0,   224,     0,     0,     0,     0,   225,     0,
   147,     0,     0,    44,     0,     0,   148,   226,     0,   227,
     0,   228,     0,     0,   229,     0,     0,   230,     0,     0,
     0,   231,     0,     0,   232,     0,   149,     0,     0,     0,
   233,     0,     0,     0,   234,   235,     0,   236,     0,   150,
     0,     0,     0,     0,     0,   151,   237,     0,   238,   239,
   240,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   241,   242,     0,     0,   243,   244,     0,     0,
   152,   245,   246,   247,   248,     0,     0,   249,   250,     0,
     0,     0,     0,     0,     0,   153
};

static const short yycheck[] = {     8,
     9,     1,    36,    31,   119,    16,    47,   119,    19,   119,
    21,    99,    44,    45,    55,    31,    27,    33,   122,    35,
   124,   125,    26,    39,    40,    41,    62,   115,    37,    38,
    34,   119,    36,   121,   122,   123,   124,   125,    66,    48,
    83,   119,    51,     0,    53,     0,    99,   124,   125,    92,
    93,    94,    95,    11,    25,   124,    27,    66,    67,    30,
    -1,    -1,   115,    72,    73,    74,    75,    76,   121,   122,
   123,   124,   125,    -1,    -1,    -1,    -1,    -1,    49,    88,
    51,    52,    -1,    92,    93,   119,    95,    58,    97,    98,
    99,    -1,    -1,    64,    -1,    -1,   105,   106,   107,    70,
    71,    -1,    -1,    -1,    -1,   114,   115,    -1,    -1,    -1,
    -1,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   119,
    91,    -1,    -1,   134,    -1,    -1,   137,   117,   139,    -1,
    -1,   147,   148,   104,    -1,   146,    -1,    -1,    -1,    -1,
    -1,   150,   151,   114,   153,   149,    -1,   156,   152,    -1,
   159,    -1,   161,    -1,    -1,    -1,    -1,    -1,    -1,   168,
    -1,    -1,    -1,    -1,   154,    -1,    -1,    -1,   177,    -1,
   179,   180,    -1,   182,    -1,   184,   185,   186,   187,   188,
   189,    -1,   191,    -1,    -1,   194,    -1,    -1,   192,    -1,
    -1,   195,    -1,    -1,    -1,    -1,    -1,    -1,   207,    -1,
    -1,    -1,   211,    -1,    -1,   209,   215,    -1,    -1,    -1,
   214,    -1,    -1,    -1,    -1,    -1,   220,   228,    -1,   223,
    -1,   232,    -1,    -1,    -1,   236,    -1,   231,    -1,    -1,
   241,   242,   243,   244,   245,   246,   247,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,   253,
    -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   255,    -1,    -1,   277,   278,
    -1,   280,    -1,    -1,   283,   284,   285,   286,   287,    -1,
    -1,    -1,   291,   292,   293,   294,   295,   296,   297,    -1,
    -1,    -1,   301,   302,    -1,    -1,    -1,    -1,   307,    -1,
   304,    -1,   306,   312,    -1,   314,    -1,    -1,    -1,    -1,
   319,   320,    -1,   317,    -1,    -1,    -1,   326,   327,   328,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   336,   337,   338,
    -1,    -1,    -1,    -1,    -1,   346,   347,   341,    -1,    -1,
    -1,    -1,    -1,    49,    50,    -1,    52,    -1,    54,    55,
    56,    -1,    -1,   343,    -1,    -1,   360,    -1,   362,    -1,
    -1,   365,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   376,    -1,    -1,    -1,    -1,   367,    -1,    -1,
   370,   371,    -1,   373,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   381,    -1,   383,   384,   385,    -1,    -1,    -1,    -1,
   390,   391,   392,   412,   413,    -1,   396,   397,    -1,    -1,
   400,   401,    -1,    -1,   404,   405,    -1,    -1,   408,   409,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,
    -1,   157,   158,    -1,   160,    -1,   162,   163,   164,   165,
   166,   167,     1,    -1,    -1,    -1,    -1,    -1,     7,    -1,
    -1,    -1,    -1,    12,    13,    14,    15,    16,    -1,    -1,
    -1,    -1,    -1,    -1,    23,    24,    -1,    -1,    -1,    -1,
    29,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    38,
    -1,    40,    41,    42,    43,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
    -1,    -1,    61,    -1,    -1,    -1,    65,    -1,    67,    68,
    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,    77,    -1,
    -1,    -1,    -1,    -1,    -1,    84,    -1,    86,    -1,    -1,
    -1,   257,    -1,    -1,   260,    -1,   262,    -1,    -1,    -1,
    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,   107,    -1,
    -1,    -1,    -1,    -1,     1,   281,   282,    -1,    -1,    -1,
     7,   120,   288,   289,   290,    12,    13,    14,    15,    16,
    -1,    -1,   298,   299,   300,    -1,    23,    24,    -1,    -1,
    -1,    -1,    29,    -1,    -1,    -1,    -1,    34,    35,    -1,
    -1,    38,    -1,    40,    41,    42,    43,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,
    -1,    -1,    -1,    -1,    61,    -1,    -1,    -1,    65,    -1,
    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    75,    -1,
    77,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    86,
     3,     4,     5,     6,    -1,     8,     9,    10,    11,    -1,
    -1,    -1,    -1,   100,    17,    18,    19,    20,    21,    22,
   107,    -1,    -1,    32,    -1,    -1,    -1,    -1,    37,    -1,
    33,    -1,    -1,   120,    -1,    -1,    39,    46,    -1,    48,
    -1,    50,    -1,    -1,    53,    -1,    -1,    56,    -1,    -1,
    -1,    60,    -1,    -1,    63,    -1,    59,    -1,    -1,    -1,
    69,    -1,    -1,    -1,    73,    74,    -1,    76,    -1,    72,
    -1,    -1,    -1,    -1,    -1,    78,    85,    -1,    87,    88,
    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   101,   102,    -1,    -1,   105,   106,    -1,    -1,
   103,   110,   111,   112,   113,    -1,    -1,   116,   117,    -1,
    -1,    -1,    -1,    -1,    -1,   118
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/afs/eos.ncsu.edu/contrib/gnu/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "/afs/eos.ncsu.edu/contrib/gnu/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 294 "s2ibis.y"
{ initialize_IBIS( VERSION_TWO_ONE ); ;
    break;}
case 2:
#line 295 "s2ibis.y"
{ return( 0 ); ;
    break;}
case 3:
#line 297 "s2ibis.y"
{ initialize_IBIS( VERSION_ONE_ONE ); ;
    break;}
case 4:
#line 298 "s2ibis.y"
{ return( 0 ); ;
    break;}
case 5:
#line 299 "s2ibis.y"
{ 
			fprintf( stderr, "s2ibis: Please begin s2ibis command " );
			fprintf( stderr, "file with [IBIS Ver] command.\n" );
			maimed = 1; 
			return(1); 
			;
    break;}
case 7:
#line 314 "s2ibis.y"
{
			commentChar = any_string[0];
			global_P->commentChar = any_string[0];
			;
    break;}
case 8:
#line 318 "s2ibis.y"
{ maimed = 1; return(1); ;
    break;}
case 9:
#line 320 "s2ibis.y"
{ ibis_P->cleanup = 1; ;
    break;}
case 10:
#line 322 "s2ibis.y"
{ ibis_P->iterate = 1; ;
    break;}
case 11:
#line 324 "s2ibis.y"
{ setUp_FileName(); ;
    break;}
case 14:
#line 328 "s2ibis.y"
{ LOAD_STRING( ibis_P->fileRev, any_string, MAX_FILE_REV_LENGTH ); ;
    break;}
case 16:
#line 331 "s2ibis.y"
{ LOAD_STRING( ibis_P->date, string, MAX_DATE_STRING_LENGTH); ;
    break;}
case 17:
#line 333 "s2ibis.y"
{ create_String( string, &( ibis_P->spiceCommand ) ); ;
    break;}
case 18:
#line 335 "s2ibis.y"
{ create_String(string, &(ibis_P->source)); ;
    break;}
case 19:
#line 337 "s2ibis.y"
{ create_String(string, &(ibis_P->notes)); ;
    break;}
case 20:
#line 339 "s2ibis.y"
{ create_String(string, &(ibis_P->disclaimer)); ;
    break;}
case 21:
#line 341 "s2ibis.y"
{ create_String(string, &(ibis_P->copyright)); ;
    break;}
case 22:
#line 343 "s2ibis.y"
{ typMinMax_P = &( global_P->tempRange ); ;
    break;}
case 24:
#line 346 "s2ibis.y"
{ typMinMax_P = &( global_P->voltageRange ); ;
    break;}
case 26:
#line 349 "s2ibis.y"
{ typMinMax_P = &( global_P->pullupRef ); ;
    break;}
case 28:
#line 352 "s2ibis.y"
{ typMinMax_P = &( global_P->pulldownRef ); ;
    break;}
case 30:
#line 355 "s2ibis.y"
{ typMinMax_P = &( global_P->powerClampRef ); ;
    break;}
case 32:
#line 358 "s2ibis.y"
{ typMinMax_P = &( global_P->gndClampRef ); ;
    break;}
case 34:
#line 361 "s2ibis.y"
{ global_P->Rload = globalFloat; ;
    break;}
case 35:
#line 363 "s2ibis.y"
{ global_P->derateVIPct = globalFloat; ;
    break;}
case 36:
#line 365 "s2ibis.y"
{ global_P->derateRampPct = globalFloat; ;
    break;}
case 37:
#line 367 "s2ibis.y"
{ global_P->simTime = globalFloat; ;
    break;}
case 38:
#line 369 "s2ibis.y"
{ typMinMax_P = &( global_P->c_comp ); ;
    break;}
case 40:
#line 372 "s2ibis.y"
{ typMinMax_P = &( global_P->pinParasitics.R_pkg ); ;
    break;}
case 42:
#line 375 "s2ibis.y"
{ typMinMax_P = &( global_P->pinParasitics.L_pkg ); ;
    break;}
case 44:
#line 378 "s2ibis.y"
{ typMinMax_P = &( global_P->pinParasitics.C_pkg ); ;
    break;}
case 47:
#line 388 "s2ibis.y"
{ ibis_P->spiceType = SPICE_TYPE_HSPICE; ;
    break;}
case 48:
#line 389 "s2ibis.y"
{ ibis_P->spiceType = SPICE_TYPE_PSPICE; ;
    break;}
case 49:
#line 390 "s2ibis.y"
{ ibis_P->spiceType = SPICE_TYPE_SPICE2; ;
    break;}
case 50:
#line 391 "s2ibis.y"
{ ibis_P->spiceType = SPICE_TYPE_SPICE3; ;
    break;}
case 51:
#line 392 "s2ibis.y"
{ ibis_P->spiceType = SPICE_TYPE_SPECTRE; ;
    break;}
case 52:
#line 402 "s2ibis.y"
{ setUp_Component(); ;
    break;}
case 55:
#line 409 "s2ibis.y"
{
	     	LOAD_STRING( component_P->manufacturer, string,
	     	 	  		 MAX_MANUFACTURERS_NAME_LENGTH);
			;
    break;}
case 56:
#line 414 "s2ibis.y"
{ setUp_SpiceFileName(); ;
    break;}
case 58:
#line 417 "s2ibis.y"
{
			LOAD_STRING( component_P->packageModel, string,
						 MAX_PACKAGE_MODEL_NAME_LENGTH );
			;
    break;}
case 59:
#line 422 "s2ibis.y"
{ typMinMax_P = &( component_P->tempRange ); ;
    break;}
case 61:
#line 425 "s2ibis.y"
{ typMinMax_P = &( component_P->voltageRange ); ;
    break;}
case 63:
#line 428 "s2ibis.y"
{ typMinMax_P = &( component_P->pullupRef ); ;
    break;}
case 65:
#line 431 "s2ibis.y"
{ typMinMax_P = &( component_P->pulldownRef ); ;
    break;}
case 67:
#line 434 "s2ibis.y"
{ typMinMax_P = &( component_P->powerClampRef ); ;
    break;}
case 69:
#line 437 "s2ibis.y"
{ typMinMax_P = &( component_P->gndClampRef ); ;
    break;}
case 71:
#line 440 "s2ibis.y"
{ component_P->Rload = globalFloat; ;
    break;}
case 72:
#line 442 "s2ibis.y"
{ component_P->derateVIPct = globalFloat; ;
    break;}
case 73:
#line 444 "s2ibis.y"
{ component_P->derateRampPct = globalFloat; ;
    break;}
case 74:
#line 446 "s2ibis.y"
{ component_P->simTime = globalFloat; ;
    break;}
case 75:
#line 448 "s2ibis.y"
{ typMinMax_P = &( component_P->c_comp ); ;
    break;}
case 77:
#line 451 "s2ibis.y"
{ typMinMax_P = &( component_P->pinParasitics.R_pkg ); ;
    break;}
case 79:
#line 454 "s2ibis.y"
{ typMinMax_P = &( component_P->pinParasitics.L_pkg ); ;
    break;}
case 81:
#line 457 "s2ibis.y"
{ typMinMax_P = &( component_P->pinParasitics.C_pkg ); ;
    break;}
case 84:
#line 462 "s2ibis.y"
{ component_P->hasPinMapping = 1; ;
    break;}
case 87:
#line 467 "s2ibis.y"
{
		        create_Model(model_PP, &model_P);
		        model_PP = &model_P;
				LOAD_STRING( model_P->modelName, any_string, 
							 MAX_MODEL_NAME_LENGTH )
				risingWave_PP = &( model_P->risingWave_P );
				fallingWave_PP = &( model_P->fallingWave_P );
			;
    break;}
case 91:
#line 495 "s2ibis.y"
{
			createDiffPin( diffPin_PP, &diffPin_P );
			diffPin_PP = &diffPin_P;
			LOAD_STRING( diffPin_P->pinName, any_string, MAX_PIN_NAME_LENGTH );
			;
    break;}
case 92:
#line 501 "s2ibis.y"
{ LOAD_STRING( diffPin_P->invPinName, any_string, 
						   MAX_PIN_NAME_LENGTH ); ;
    break;}
case 93:
#line 504 "s2ibis.y"
{ diffPin_P->vdiff = globalFloat; ;
    break;}
case 94:
#line 506 "s2ibis.y"
{ diffPin_P->tdelayTyp = globalFloat; ;
    break;}
case 96:
#line 510 "s2ibis.y"
{ diffPin_P->tdelayMin = NOT_USED;
							diffPin_P->tdelayMax = NOT_USED; ;
    break;}
case 97:
#line 513 "s2ibis.y"
{ diffPin_P->tdelayMin = globalFloat; ;
    break;}
case 98:
#line 515 "s2ibis.y"
{ diffPin_P->tdelayMax = globalFloat; ;
    break;}
case 101:
#line 533 "s2ibis.y"
{
			createPinMap( pinMap_PP, &pinMap_P );
			pinMap_PP = &pinMap_P;
			LOAD_STRING( pinMap_P->pinName, any_string,
						 MAX_PIN_MAPPING_NAME_LENGTH );
			;
    break;}
case 102:
#line 540 "s2ibis.y"
{ LOAD_STRING( pinMap_P->pullupRef, any_string,
						   MAX_PIN_MAPPING_NAME_LENGTH ); ;
    break;}
case 103:
#line 543 "s2ibis.y"
{ LOAD_STRING( pinMap_P->pulldownRef, any_string,
						   MAX_PIN_MAPPING_NAME_LENGTH ); ;
    break;}
case 106:
#line 550 "s2ibis.y"
{ LOAD_STRING( pinMap_P->powerClampRef, any_string,
						   MAX_PIN_MAPPING_NAME_LENGTH ); ;
    break;}
case 107:
#line 553 "s2ibis.y"
{ LOAD_STRING( pinMap_P->gndClampRef, any_string,
						   MAX_PIN_MAPPING_NAME_LENGTH ); ;
    break;}
case 112:
#line 593 "s2ibis.y"
{
			create_Pin( pin_PP, &pin_P );
			pin_PP = &pin_P;
			LOAD_STRING( pin_P->pinName, any_string, MAX_PIN_NAME_LENGTH );
			;
    break;}
case 113:
#line 599 "s2ibis.y"
{
			LOAD_STRING( pin_P->spiceNodeName, any_string, 
						 MAX_PIN_NAME_LENGTH );
			;
    break;}
case 114:
#line 604 "s2ibis.y"
{
			LOAD_STRING( pin_P->signalName, any_string, 
						 MAX_SIGNAL_NAME_LENGTH );
			;
    break;}
case 115:
#line 609 "s2ibis.y"
{
			LOAD_STRING( pin_P->modelName, any_string, MAX_MODEL_NAME_LENGTH );
			;
    break;}
case 117:
#line 616 "s2ibis.y"
{
			LOAD_STRING( pin_P->inputPin, any_string, MAX_PIN_NAME_LENGTH );
			;
    break;}
case 118:
#line 622 "s2ibis.y"
{
			LOAD_STRING( pin_P->inputPin, any_string, MAX_PIN_NAME_LENGTH );
			;
    break;}
case 119:
#line 626 "s2ibis.y"
{
			LOAD_STRING( pin_P->enablePin, any_string, MAX_PIN_NAME_LENGTH );
			;
    break;}
case 121:
#line 638 "s2ibis.y"
{ pin_P->R_pin = globalFloat;;
    break;}
case 122:
#line 639 "s2ibis.y"
{ pin_P->L_pin = globalFloat;;
    break;}
case 123:
#line 640 "s2ibis.y"
{ pin_P->C_pin = globalFloat;;
    break;}
case 129:
#line 655 "s2ibis.y"
{
			model_P->simTime = globalFloat;
			;
    break;}
case 130:
#line 659 "s2ibis.y"
{ 
			model_P->Vinl = globalFloat; 
			;
    break;}
case 131:
#line 663 "s2ibis.y"
{ 
			model_P->Vinh = globalFloat; 
			;
    break;}
case 132:
#line 667 "s2ibis.y"
{ 
			model_P->Vmeas = globalFloat; 
			;
    break;}
case 133:
#line 671 "s2ibis.y"
{ 
			model_P->Cref = globalFloat; 
			;
    break;}
case 134:
#line 675 "s2ibis.y"
{ 
			model_P->Rref = globalFloat; 
			;
    break;}
case 135:
#line 679 "s2ibis.y"
{ 
			model_P->Vref = globalFloat; 
			;
    break;}
case 136:
#line 683 "s2ibis.y"
{ 
			model_P->Rload = globalFloat; 
			;
    break;}
case 137:
#line 687 "s2ibis.y"
{ 
			model_P->derateRampPct = globalFloat; 
			;
    break;}
case 138:
#line 691 "s2ibis.y"
{ 
			model_P->derateVIPct = globalFloat; 
			;
    break;}
case 139:
#line 695 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->c_comp); 
			;
    break;}
case 141:
#line 700 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->tempRange); 
			;
    break;}
case 143:
#line 705 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->voltageRange); 
			;
    break;}
case 145:
#line 710 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->pullupRef); 
			;
    break;}
case 147:
#line 715 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->pulldownRef); 
			;
    break;}
case 149:
#line 720 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->powerClampRef); 
			;
    break;}
case 151:
#line 725 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->gndClampRef); 
			;
    break;}
case 153:
#line 730 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->Rgnd); 
			;
    break;}
case 155:
#line 735 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->Rpower); 
			;
    break;}
case 157:
#line 740 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->Rac); 
			;
    break;}
case 159:
#line 745 "s2ibis.y"
{ 
			typMinMax_P = &(model_P->Cac); 
			;
    break;}
case 161:
#line 750 "s2ibis.y"
{
			createWaveTable( risingWave_PP, 1 );
			risingWave_P = *risingWave_PP;
			risingWave_PP = &( risingWave_P->nextWaveTable_P );
			;
    break;}
case 163:
#line 757 "s2ibis.y"
{
			createWaveTable( fallingWave_PP, 1 );
			fallingWave_P = *fallingWave_PP;
			fallingWave_PP = &( fallingWave_P->nextWaveTable_P );
			;
    break;}
case 165:
#line 768 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_INPUT; ;
    break;}
case 166:
#line 770 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_OUTPUT; ;
    break;}
case 167:
#line 772 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_3_STATE; ;
    break;}
case 168:
#line 774 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_OPEN_DRAIN; ;
    break;}
case 169:
#line 776 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_I_O; ;
    break;}
case 170:
#line 778 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_I_O_OPEN_DRAIN; ;
    break;}
case 171:
#line 780 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_I_O_OPEN_SINK; ;
    break;}
case 172:
#line 782 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_I_O_OPEN_SOURCE; ;
    break;}
case 173:
#line 784 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_INPUT_ECL; ;
    break;}
case 174:
#line 786 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_I_O_ECL; ;
    break;}
case 175:
#line 788 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_TERMINATOR; ;
    break;}
case 176:
#line 790 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_OPEN_SINK; ;
    break;}
case 177:
#line 792 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_OPEN_SOURCE; ;
    break;}
case 178:
#line 794 "s2ibis.y"
{ model_P->modelType = MODEL_TYPE_OUTPUT_ECL; ;
    break;}
case 179:
#line 798 "s2ibis.y"
{ model_P->polarity = MODEL_POLARITY_NON_INVERTING; ;
    break;}
case 180:
#line 800 "s2ibis.y"
{ model_P->polarity = MODEL_POLARITY_INVERTING; ;
    break;}
case 181:
#line 804 "s2ibis.y"
{ model_P->enable = MODEL_ENABLE_ACTIVE_HIGH; ;
    break;}
case 182:
#line 806 "s2ibis.y"
{ model_P->enable = MODEL_ENABLE_ACTIVE_LOW; ;
    break;}
case 183:
#line 810 "s2ibis.y"
{ risingWave_P->R_fixture = globalFloat; ;
    break;}
case 184:
#line 811 "s2ibis.y"
{ risingWave_P->V_fixture = globalFloat; ;
    break;}
case 185:
#line 812 "s2ibis.y"
{ risingWave_P->V_fixture_min = globalFloat; ;
    break;}
case 186:
#line 813 "s2ibis.y"
{ risingWave_P->V_fixture_max = globalFloat; ;
    break;}
case 187:
#line 814 "s2ibis.y"
{ risingWave_P->L_fixture = globalFloat; ;
    break;}
case 188:
#line 815 "s2ibis.y"
{ risingWave_P->C_fixture = globalFloat; ;
    break;}
case 189:
#line 816 "s2ibis.y"
{ risingWave_P->R_dut = globalFloat; ;
    break;}
case 190:
#line 817 "s2ibis.y"
{ risingWave_P->L_dut = globalFloat; ;
    break;}
case 191:
#line 818 "s2ibis.y"
{ risingWave_P->C_dut = globalFloat; ;
    break;}
case 193:
#line 822 "s2ibis.y"
{ fallingWave_P->R_fixture = globalFloat; ;
    break;}
case 194:
#line 823 "s2ibis.y"
{ fallingWave_P->V_fixture = globalFloat; ;
    break;}
case 195:
#line 824 "s2ibis.y"
{ fallingWave_P->V_fixture_min = globalFloat; ;
    break;}
case 196:
#line 825 "s2ibis.y"
{ fallingWave_P->V_fixture_max = globalFloat; ;
    break;}
case 197:
#line 826 "s2ibis.y"
{ fallingWave_P->L_fixture = globalFloat; ;
    break;}
case 198:
#line 827 "s2ibis.y"
{ fallingWave_P->C_fixture = globalFloat; ;
    break;}
case 199:
#line 828 "s2ibis.y"
{ fallingWave_P->R_dut = globalFloat; ;
    break;}
case 200:
#line 829 "s2ibis.y"
{ fallingWave_P->L_dut = globalFloat; ;
    break;}
case 201:
#line 830 "s2ibis.y"
{ fallingWave_P->C_dut = globalFloat; ;
    break;}
case 203:
#line 835 "s2ibis.y"
{
			LOAD_STRING( model_P->modelFileTyp, any_string, 
						 MAX_FILENAME_LENGTH );
			;
    break;}
case 204:
#line 840 "s2ibis.y"
{
			LOAD_STRING( model_P->modelFileMin, any_string, 
						 MAX_FILENAME_LENGTH );
			;
    break;}
case 205:
#line 845 "s2ibis.y"
{
			LOAD_STRING( model_P->modelFileMax, any_string, 
						 MAX_FILENAME_LENGTH );
			;
    break;}
case 208:
#line 858 "s2ibis.y"
{ any_string= yyvsp[0].id; ;
    break;}
case 209:
#line 859 "s2ibis.y"
{ any_string= lastNumberAsText; ;
    break;}
case 210:
#line 860 "s2ibis.y"
{ any_string= lastNumberAsText; ;
    break;}
case 211:
#line 861 "s2ibis.y"
{ strcpy( any_string, "GND" ); ;
    break;}
case 212:
#line 862 "s2ibis.y"
{ strcpy( any_string, "POWER" ); ;
    break;}
case 213:
#line 863 "s2ibis.y"
{ strcpy( any_string, "NC" ); ;
    break;}
case 214:
#line 864 "s2ibis.y"
{ strcpy( any_string, "NA" ); ;
    break;}
case 215:
#line 867 "s2ibis.y"
{ typMinMax_P->typ = globalFloat; ;
    break;}
case 216:
#line 868 "s2ibis.y"
{ typMinMax_P->min = globalFloat; ;
    break;}
case 217:
#line 869 "s2ibis.y"
{ typMinMax_P->max = globalFloat; ;
    break;}
case 219:
#line 873 "s2ibis.y"
{globalFloat = USE_NA;;
    break;}
case 220:
#line 876 "s2ibis.y"
{ globalFloat = yyvsp[0].dval; ;
    break;}
case 221:
#line 877 "s2ibis.y"
{ globalFloat = (double) yyvsp[0].ival; ;
    break;}
case 222:
#line 881 "s2ibis.y"
{ stringLength = 0; string[0] = 0; ;
    break;}
case 223:
#line 883 "s2ibis.y"
{ string[stringLength] = 0;/* replace last eol */;
    break;}
case 226:
#line 891 "s2ibis.y"
{
			length = MAX(MAX_TMP_STRING_LEN-stringLength,0);
			if(length)
			  {
			  strncat(string, any_string,length);
			  strncat(string,  " ", length--);
			  stringLength = strlen(string);
			  }
			;
    break;}
case 227:
#line 901 "s2ibis.y"
{
			if(!stringLength)
			  {
			  length = MAX(MAX_TMP_STRING_LEN-stringLength,0);
			  strncat(string,  " ", length);
			  stringLength++;
			  }
			;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "/afs/eos.ncsu.edu/contrib/gnu/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 911 "s2ibis.y"


#include "s2ilex.c"



/*
 * yyerror--
 *	Do something (print it for now) with an error message.
 */
int yyerror(char *s)

{

char *b, *c;
int i;

fprintf( stderr, "\n\ns2ibis2: Error at line %d: %s\n", lineNum, s );
fprintf( stderr, "Token:\n" );
for ( c = yytext; (*c && (*c != '\n')); c++ )
	if ( *c == universalCommentIndicator )
		putchar( commentChar );
	else
		putchar( *c );
fprintf( stderr, "\n");
#ifdef FLEX_SCANNER
	fprintf( stderr, "Current Buffer:\n");
	for (b = yytext;
	  (b >= YY_CURRENT_BUFFER->yy_ch_buf && (*b != '\n')); b--);
	for (c = b+1,i=0; (*c && (*c != '\n') && i < MAX_LINE_LENGTH); i++, c++)
	  if (*c == universalCommentIndicator)
	    putc(commentChar, stderr);
	  else
	    putc(*c, stderr);
	fprintf(stderr, "\n");
	for ( c = b+1, i=0; 
		  strncmp( c,yytext,yyleng ) && *c && (*c != '\n') && 
		  i < MAX_LINE_LENGTH;
		  i++, c++ ) 
		{
		if (*c == '\t')
			putc('\t', stderr);
		else
			putc(' ', stderr);
		}
	putc('^', stderr);
	fprintf( stderr, "\n\n");
#endif

maimed = 1;
return(1);
}


void InitScan(char *file)
{
if ( (yyin = fopen( file, "r" ) ) == NULL )
	{
	fprintf( stderr, "s2ibis2: unable to open input file for reading.\n" );
	exit( 1 );
	}
else
	{
	lineNum = 1;
	thisDepth = 0;
	maimed = 0;
	}
}


/*
 * s2ibisRead
 *
 * This is the entry point to the parser
 *
 * Parameters:
 *	file: Name of the file to be searched
 *	ibisStruc_PP: pointer to the pointer of the data structure that
 *			  contains the information in the IBIS file>
 *	instruction: Instruction passed from the calling routin to
 *			  ibis1_1Read. It must be one of the following:
 *			  "new"		create a new data structure and
 *					transfer all of the information
 *					in the IBIS file into it.
 */

int s2ibisRead(	IN 		char *file, 
				INOUT	ibisTOP_Pt *ibisStruc_PP,
				INOUT	ibisGlobal_Pt	*ibisGlobal_PP,
               	IN 		char *instruction, 
				OUT 	char **report_P)
{
InitScan( file );
if( !strcmp( instruction,"new" ) )
	{
	create_TOP( ibisStruc_PP, file );
	createGlobal( ibisGlobal_PP );
	}
else
	{
	fprintf( stderr, "s2ibis2: Internal error--" );
	fprintf( stderr, "illegal instruction to parser.\n" );
	fprintf( stderr, "s2ibis2: Quit mucking about with my source code!\n" );
	return( 1 );
	}
    
ibis_P = *ibisStruc_PP;
global_P = *ibisGlobal_PP;

fprintf( stderr, "s2ibis2: Reading input file %s...", file );
if ( maimed || yyparse() )
	{
	fprintf( stderr, "s2ibis2: Errors in IBIS file prevent continuation.\n" );
	fclose( yyin );
	return( 1 );
	}
fclose( yyin );
fprintf( stderr, "done.\n" );
return( 0 );
}





void create_String(char *sin, char **sout)
{
int i = 0;

while ( ( sin[0] == ' ' ) || ( sin[0] == '\t' ) )
	sin++;
length = strlen(sin);
if ( length > MAX_IBIS_STRING_LENGTH )
	{
	sin[MAX_IBIS_STRING_LENGTH] = ' ';
	sin[MAX_IBIS_STRING_LENGTH+1] = '.';
	sin[MAX_IBIS_STRING_LENGTH+2] = '.';
	sin[MAX_IBIS_STRING_LENGTH+3] = '.';
	sin[MAX_IBIS_STRING_LENGTH+4] = 0;
	length = MAX_IBIS_STRING_LENGTH+4;
	}
if ( (*sout = (char *) MALLOC(length +1)) == NULL )
	yyerror("Out of memory");
else
	strncpy(*sout,sin,length);	
}

void recreate_String(char *sin, char **sout)
{
if(*sout != NULL) 
	FREE(*sout);
create_String(sin, sout);
}

/*
 * initialize_IBIS
 */
void initialize_IBIS(IN int versionID)
{
ibis_P->ibisVersion = versionID;
component_PP = &( ibis_P->components_P );
component_P = NULL;
model_P = NULL;
model_PP = NULL;
pin_P = NULL;
pin_PP = NULL;
pinMap_P = NULL;
pinMap_PP = NULL;
diffPin_P = NULL;
diffPin_PP = NULL;
risingWave_P = NULL;
risingWave_PP = NULL;
fallingWave_P = NULL;
fallingWave_PP = NULL;
return;
}

/*
 * setUp_Component();
 */
void setUp_Component()
{
create_Component( component_PP, &component_P );
component_PP = &component_P;
LOAD_STRING( component_P->component, string, MAX_COMPONENT_NAME_LENGTH );
pin_PP = &( component_P->pins_P );
model_PP = &( component_P->models_P );
pinMap_PP = &( component_P->pinMap_P );
diffPin_PP = &( component_P->diffPin_P );
}



/*
 * setUp_FileName;
 */
int setUp_FileName( void )

{
int	i,
	length;

length = strlen( any_string );
INITIAL_LOAD_STRING( ibis_P->thisFileName, any_string, MAX_FILENAME_LENGTH );
if ( ( length > MAX_FILENAME_LENGTH ) ||
     !strcmp( &((ibis_P->thisFileName)[length-3]), ".ibs" ) )
	{
	yyerror( "Invalid filename: must be of the form 'xxxxxxxx.ibs'" );
	maimed = 1;
	return( 1 );
	}
for ( i = 0; i < length - 4; i++ )
	if ( isupper( any_string[i] ) )
		{
		yyerror( "Invalid filename: must be lower case" );
		maimed = 1;
		return( 1 );
		}
}




/*
 * setUp_SpiceFileName;
 */
int setUp_SpiceFileName( void )

{
int	i,
	length;

length = strlen( any_string );
INITIAL_LOAD_STRING( component_P->spiceFile, any_string, MAX_FILENAME_LENGTH );
if ( ( length > MAX_FILENAME_LENGTH ) )
	{
	yyerror( "Invalid filename length: must be of the form 'xxxxxxxx.xxx'" );
	maimed = 1;
	return( 1 );
	}
for ( i = 0; i < length - 4; i++ )
	if ( isupper( any_string[i] ) )
		{
		yyerror( "Invalid filename: must be lower case" );
		maimed = 1;
		return( 1 );
		}
}
