*Lipa Laboratories, Inc.
*Lipa Labs 74LLC80486
*SO20 
*CMOS 
*[File Rev] 42
*[Spice] 3
*[Iterate]
*[Package]
*| variable            typ              min              max
*R_pkg                 2.0m             1.0m             3.0m
*L_pkg                 5.0nH            4.0nH            6.0nH
*C_pkg                 8.0pF            7.0pF            9.0pF
*[Source] Here's what happens when you put in a source line. 
*         Here's what happens when you put in a second source line.
*         You may put in as many lines as you like.
*[Disclaimer] An example of a multi-line disclaimer:
*             No matter what happens, I am not responsible.
*             You may put in as many lines as you like.
*[Notes] Notes works the same way as disclaimer.
*        You may put in as many lines as you like.
*[Pin] signal_name    model_name    R_pin   L_pin   C_pin
* three  gozouta        Buffer1     200.0m  5.0nH   2.5pF     
* Output 31  2.0E-8  four 
**Polarity        Non-Inverting
**  N.B. !!!! this really is an inverting output!
* four   In1            Input1 
* Input  21   1   0.0  5.0
* five   In2            Input2 
* Input  21   1   0.0  5.0
* six    In3            Input1 
* Input  21   1   0.0  5.0
* seven  In4            Input3 
* Input  21   1   0.0  5.0
**NoModel
*  7     GND            GND
*  GND    0
*  8     gozer          Buffer2     200.0m  5.0nH   2.5pF
* 3-state 41  2.0E-8 eight nine
**C_comp           5.0pF         3.0pF         7.0pF
* eight   In4           Input1
* Input  51   1   0.0  5.0
**NoModel
* nine    En2           Enable1
* Input  61   1  0.0  5.0
*  14    VCC            POWER
*  POWER  99 5.0 4.5 5.5
*[Endpin]
*****  s2ibis SPICE INPUT DECK   *****

*VDD 99 0 5.0V
*
* Note: We're changing the ground connection from node 0 to 
*       node 98:
*
*VGND 98 0 0V

X1 99 21 31 98 INVA
X2 99 51 41 61 71 98 TRIINVA
X3 99 61 71 98 INVA

D1 21 99 CLMP1
D2 98 21 CLMP1
D3 51 99 CLMP2
D4 98 51 CLMP2
D5 61 99 CLMP3
D6 98 61 CLMP4

* 199 = Vcc
* 198 = GND
* 121 = Input
* 131 = Output
*
.SUBCKT INVA 199 121 131 198
M1 131 121 199 199 CMOSP l=0.67u w=1599.6u ad=978.26p as=978.26p pd=429.48u
+ ps=429.48u nrd=0.06 nrs=0.04
M2 131 121 198 198 CMOSN l=0.67u w=700.6u ad=888.75p as=888.75p pd=376.58u
+ ps=375.93u nrd=0.06 nrs=0.04
.ENDS

.SUBCKT TRIINVA 199 121 131 141 151 198
M1 131 121 161 199 CMOSP l=0.67u w=1599.6u ad=978.26p as=978.26p pd=429.48u
+ ps=429.48u nrd=0.06 nrs=0.04
M2 131 121  171 198 CMOSN l=0.67u w=700.6u ad=888.75p as=888.75p pd=376.58u
+ ps=375.93u nrd=0.06 nrs=0.04
M3 161 141 199 199 CMOSP l=0.67u w=1599.6u ad=978.26p as=978.26p pd=429.48u
+ ps=429.48u nrd=0.06 nrs=0.04
M4 171 151 198 198 CMOSN l=0.67u w=700.6u ad=888.75p as=888.75p pd=376.58u
+ ps=375.93u nrd=0.06 nrs=0.04
.ENDS

*[Include_typ] tryme.typ
*[Include_min] tryme.min
*[Include_max] tryme.max
.END
